#include "PConfig.h"
#include <sys/ioctl.h>
#include <unistd.h>
#include <fcntl.h>
#ifdef P__LINUX
#include <sys/soundcard.h>
#endif
#include <stdio.h>
#include <math.h>
#include <TSeries.hh>
#include <iostream>
#include <iomanip>

#define BUF_SIZE 4096*40*4
int audio_fd;
unsigned char audio_buffer[BUF_SIZE];

char DEVICE_NAME[]="/dev/dsp";

void playTSeries(int* dev,TSeries& ts,int debug) {
  int speed;
  int N;
  int nn;
  int ii;
  double max=0;
  double v;
#ifdef P__LINUX
  int format=AFMT_S16_NE;
#else
  int format=0;
#endif
  int channels = 2;
  int val;
  bool first =false;
  if (*dev==-1) {
    if((audio_fd = open(DEVICE_NAME, O_RDWR || O_NONBLOCK, 0)) == -1) { printf("open error\n"); }
    *dev=audio_fd;
    first=true;
  } else { audio_fd=*dev; }
  speed=int(1.0/ts.getTStep());
  if(debug) std::cout <<"playTSeries: speed    = "<<speed<<std::endl;
  if(debug) std::cout <<"playTSeries: format   = "<<format<<std::endl;  
  if(debug) std::cout <<"playTSeries: chann    = "<<channels<<std::endl;
#ifdef P__LINUX
  if(first) { 
    if(ioctl(audio_fd,SNDCTL_DSP_SPEED, &speed)==-1) { printf("sampling rate error"); }
    if(ioctl(audio_fd,SNDCTL_DSP_SETFMT, &format)==-1) { printf("format error"); }
    if(ioctl(audio_fd,SNDCTL_DSP_CHANNELS, &channels)==-1) { printf("channels error"); }
  }
#endif

  if(debug) std::cout <<"playTSeries: HW-speed = "<<speed<<std::endl;  
  if(debug) std::cout <<"playTSeries: HWformat = "<<format<<std::endl;  
  if(debug) std::cout <<"playTSeries: HWchann  = "<<channels<<std::endl;  
  N=ts.getNSample();
  if(debug) std::cout <<"playTSeries: N        = "<<N<<std::endl;
  if(debug) std::cout <<"playTSeries: BUF_SIZE = "<<BUF_SIZE<<std::endl;  
  double *buf=new double[N];
  ts.getData(N,buf);
  for(nn=0;nn<N;++nn) {
    v=buf[nn];
    if(v>max) max=v;
    if(-v>max) max=-v;
  }
  if(debug) std::cout <<"playTSeries: max      = "<<max<<std::endl;
  
  for(nn=0;nn<N;) {
    for(ii=0;ii<BUF_SIZE && nn<N;) {
      val=int(256.0*128.0*buf[nn]);
      //val=int(80.0*sin(2*3.1415*double(nn)/double(speed)*200.0));
      audio_buffer[ii]=(unsigned char)(val & 0xff);
      ++ii;
      audio_buffer[ii]=(unsigned char)((val >> 8)& 0xff);      
      ++ii;
      audio_buffer[ii]=(unsigned char)(val & 0xff);
      ++ii;
      audio_buffer[ii]=(unsigned char)((val >> 8)& 0xff);
      ++nn;
      ++ii;
    }
  int len;
  if((len = write(audio_fd,audio_buffer,ii)) == -1) { printf("write error\n"); }
  if(debug) std::cout <<"playTSeries: len      = "<<len<<std::endl;
  }
  delete buf;
  //close(audio_fd); 
}
