#! /ldcg/bin/perl -w
#
#   Build an html table describing all installed monitors.
#
#   At entry the MONITORS environment variable contains a list of 
#   Monitors that are to be included in the table and the necessary 
#   data files for each monitor are in directories $docpath/<monitor>/
#
$docpath="../doc/Monitors";
print "<html>\n";
print "<head>\n";
print "<title>Monitor table</title>\n";
print "<center>\n";
print "<table>\n";
print "<tr>\n";
print "<td wid=20%>Monitor</td>\n";
print "<td wid=20%>Author</td>\n";
print "<td wid=20%>DCC ID</td>\n";
print "<td wid=40%>Summary</td>\n";
print "</tr>\n";
chomp($cwd=`pwd`);
$docpath="$cwd/$docpath" if (substr($docpath,0,1) =~ "\.");
foreach my $i ( sort( split(' ', $ENV{MONITORS}) ) ) {
    my $fx="$docpath/$i/$i";

    if ( -e "$docpath/$i/index.html" ) {
	print "<tr><td><a href=$i/index.html>$i</a></td>\n";
    } elsif ( -e "$fx.html" ) {
	print "<tr><td><a href=$i/$i.html>$i</a></td>\n";
    } elsif ( -e "$fx.pdf" ) {
	print "<tr><td><a href=$i/$i.pdf>$i</a></td>\n";
    } else {
	print "<tr><td><a href=$i/index.html>$i</a></td>\n";
    }

    my $author="-";
    if ( -e "$fx.author" ) {
	open (AUTHORFILE, "<$fx.author") or die("Can't open $fx.author\n");
	if (defined($author=<AUTHORFILE>)) {
	    if ($author =~ /(.*)<(.*)>/) {
		$author = "<a href=mailto:$2>$1</a>";
	    } else {
		print "author=$author\n";
	    }
	} else {
	    $author = "-";
	}
	close AUTHORFILE;
    }
    print "<td>$author</td>\n";

    my $dccdoc="-";
    if ( -e "$i/$i.dccdoc" ) {
	open DCCFILE, "<$fx.dccdoc" or die("Can't open $fx.dcc\n");
	if (!defined($dccdoc=<DCCFILE>)) {
	    $dccdoc = '-';
	}
	close DCCFILE;
    }
    print "<td>$dccdoc</td>\n";

    my $synopsis="-";
    if ( -e "$fx.synopsis" ) {
	open SYNOPFILE, "$fx.synopsis" or die("Can't open $fx.synopsis\n");
	if (!defined($synopsis=<SYNOPFILE>)) {
	    $synopsis = "-";
	}
	close SYNOPFILE;
    }
    print "<td>$synopsis</td></tr>\n";
}
print "</table>\n";
print "</center>\n";
print "</head>\n";
print "</html>\n";
